#include <Windows.h> 
#include <process.h>
#include <ctype.h>
#include <stdio.h>
#include <string>
#include <iostream>
#include <vector>
#include <assert.h>
#include <tchar.h>

int doParrallelGrep(std::string pattern, std::vector<std::string> files);

int main(int argc, char *argv[])
{
	using namespace std;
	if (argc < 2)
	{
		std::cout << "Arguments number is not enought" << std::endl;
		return -1;
	}
	vector<string> files;
	for (int i = 2; i < argc; i++)
		files.push_back(string(argv[i]));

	doParrallelGrep(string(argv[1]), files);
	return 0;
}

int doParrallelGrep(std::string pattern, std::vector<std::string> files)
{
	using namespace std;
	vector<string>::iterator it;
	vector<HANDLE>::iterator itH;
	vector<HANDLE> handles;
	vector<HANDLE> procs;
	vector<string> tmp_names;

	STARTUPINFO StartUP;
	PROCESS_INFORMATION ProcInfo;

	GetStartupInfo(&StartUP);

	for (it = files.begin(); it != files.end(); ++it)
	{
		LPTSTR tmpName = new TCHAR[MAX_PATH];
		string cmd("findstr ");
		cmd.append(pattern);
		cmd.append(" ");
		cmd.append(*it);

		GetTempFileName(_T("."), _T("gtm"), 0, tmpName);
		tmp_names.push_back(tmpName);

		SECURITY_ATTRIBUTES StdSA = { sizeof(SECURITY_ATTRIBUTES), NULL, TRUE };

		HANDLE TmpH = CreateFile(tmpName, GENERIC_ALL, FILE_SHARE_READ | FILE_SHARE_WRITE, &StdSA, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		StartUP.dwFlags = STARTF_USESTDHANDLES;
		StartUP.hStdOutput = TmpH;
		StartUP.hStdError = TmpH;
		StartUP.hStdInput = GetStdHandle(STD_INPUT_HANDLE);

		CreateProcess(NULL, (LPSTR)cmd.c_str(), NULL, NULL, TRUE, 0, NULL, NULL, &StartUP, &ProcInfo);

		procs.push_back(ProcInfo.hProcess);
		handles.push_back(TmpH);
	}
	int i = 0; 
	for (itH = procs.begin(); itH != procs.end(); ++itH)
	{
		WaitForSingleObject(*itH, INFINITE);
		DWORD ExCode; 
		GetExitCodeProcess(*itH, &ExCode);
		if (ExCode == 0)
		{
//			HANDLE File = CreateFile((LPCSTR)tmp_names[i].c_str(), GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
			HANDLE MapH = CreateFileMapping(handles[i], NULL, PAGE_READONLY, 0, 0, NULL);
			DWORD Size = GetFileSize(handles[i], NULL);
			char *mem = (char *)MapViewOfFile(MapH, FILE_MAP_READ, 0, 0, Size);
			printf("%s \n", mem);
			
			UnmapViewOfFile(MapH);
			CloseHandle(handles[i]);
			DeleteFile((LPCSTR)tmp_names[i].c_str());
			i++;
		}
	}

	return 0;
}

