#include "File.h"
#include <stdio.h>
#include <cstdlib>
#include <clocale>


File::File(std::wstring lpath) : path(lpath)
{
	LPCWSTR lppath = (LPCWSTR)lpath.c_str();
	
	HANDLE fd = CreateFile(
		lppath,
		GENERIC_READ | GENERIC_WRITE,
		0,
		NULL,
		CREATE_NEW,
		FILE_ATTRIBUTE_NORMAL,
		NULL
		);
	DWORD code = GetLastError();
	file = fd;
}

File::~File()
{
	CloseHandle(file);
}

int16_t File::read(void *buff, int len)
{
	DWORD nRead;
	bool result = ReadFile(file, buff, len, &nRead, NULL);
	return (int16_t)nRead;
}

int16_t File::write(void *buff, int len)
{
	DWORD nWrite;
	WriteFile(file, buff, len, &nWrite, NULL);
	return (int16_t)nWrite;
}

void File::CopyByLibC(std::wstring to)
{
	size_t newPathLen = to.length()+1;
	size_t num; 

	char *newPath = new char[newPathLen];

	wcstombs_s(&num, newPath, newPathLen, to.c_str(), newPathLen);

	FILE *fd;
	errno_t fstatus = fopen_s(&fd,newPath, "wb");

	char *buff = new char[512];

	DWORD readed;
	SetFilePointer(file, 0, NULL, FILE_BEGIN);

	do
	{
		ReadFile(file, buff, 512, &readed, NULL);
		fwrite(buff, sizeof(char), readed, fd);
	} while (readed == 512);

	fclose(fd);
	delete[] buff;
	delete[] newPath;
	return;
}
void File::CopyByCP(std::wstring to)
{
	bool ret = CopyFile((LPCWSTR)path.c_str(), (LPCWSTR)to.c_str(), FALSE);
	return;
}
void File::CopyByRW(std::wstring to)
{
	File *nFile = new File(to);
	char *buff = new char[512];

	HANDLE nFileHandler = nFile->file;
	SetFilePointer(file, 0, NULL, FILE_BEGIN);

	DWORD readed,writen;
	do
	{
		bool read_result  = ReadFile(file, (LPVOID)buff, 512, &readed, NULL);
		bool write_result = WriteFile(nFileHandler, (LPVOID)buff, readed, &writen, NULL);
	} while (readed == 512);

	delete[] buff;
}