#include "FileWithHeap.h"

FileWithHeap::FileWithHeap(std::wstring lpath) : path(lpath)
{
	file = NULL;
	ptr_tofile = NULL;
	heap_handle = NULL;
}

FileWithHeap::~FileWithHeap()
{
	if (ptr_tofile != NULL || heap_handle != NULL)
	{
		HeapDestroy(heap_handle);
		flush();
	}

	if (file != NULL)
		CloseHandle(file);
}

void *FileWithHeap::getPtr()
{

	if (file == NULL)
		file = getHandle();
	
	if (heap_handle == NULL)
	{
		int size = getFileSize();

		heap_handle = HeapCreate(HEAP_NO_SERIALIZE, 0x01000, 0);
		ptr_tofile = HeapAlloc(heap_handle, 0, size);

		bool result = ReadFile(file, (LPVOID)ptr_tofile, size, NULL, NULL);
	}

	return  ptr_tofile;
}

int FileWithHeap::getFileSize()
{
	if (file == NULL)
		file = getHandle();

	int size = GetFileSize(file, NULL);
	return size;
}

HANDLE FileWithHeap::getHandle()
{
	HANDLE HFile = CreateFile(path.c_str(), GENERIC_ALL, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (file == INVALID_HANDLE_VALUE)
	{
		throw  new std::exception("Error on file open");
	}

	DWORD er = GetLastError();
	return HFile;
}

void FileWithHeap::flush()
{
	bool result = WriteFile(file, (LPCVOID)ptr_tofile, getFileSize(), NULL, NULL);
}

FileWithHeap &FileWithHeap::copy(std::wstring new_path)
{
	CopyFile(path.c_str(), new_path.c_str(), false);
	FileWithHeap *nPath = new FileWithHeap(new_path);

	return *nPath;
}