#include "SorterFactory.h"
#include <memory>

Sorter &SorterFactory::getInstance(TypeOfSort type)
{
	switch (type)
	{
	case QuickSort:
		return getQuickSorter();
	case RadixSort:
		return getRadixSorter();
	default:
		return getQuickSorter();
	}
}

QuickSorter &SorterFactory::getQuickSorter()
{
	static QuickSorter sorter;
	return sorter;
}

RadixSorter &SorterFactory::getRadixSorter()
{
	static RadixSorter sorter;
	return sorter;
}